#include "Smart_bot_Functions.h"
#include <avr/wdt.h>
#include "NewPing.h"
#include "DeviceDriverSet_xxx0.h"

//DeviceDriverSet_ULTRASONIC myUltrasonic;
//#include "Smart_bot_Functions.ino"
/*
int ENA=5;
int ENB=6;
int IN1=7;
int IN2=8;
int IN3=9;
int IN4=11;int STBY = 3;
*/
void setup() {
  // put your setup code here, to run once:
  digitalWrite(STBY,OUTPUT);  // These two lines of code where under the comment section of Lesson #4 by @NOS187. This helps with smart robot car V4.
  digitalWrite(STBY,HIGH); // STBY is set to high, taking this as the code is ready to commmence. (using it to stop function calls on motors).
  pinMode(ENA,OUTPUT);
  pinMode(ENB,OUTPUT);
  pinMode(IN1,OUTPUT);
  pinMode(IN2,OUTPUT);
  pinMode(IN3,OUTPUT);
  pinMode(IN4,OUTPUT);
  digitalWrite(ENA,HIGH);
  digitalWrite(ENB,HIGH);

  Serial.begin(9600);
 // myUltrasonic.DeviceDriverSet_ULTRASONIC_Init();
}

void loop() {

 // myUltrasonic.DeviceDriverSet_ULTRASONIC_Test();

  int sensorValue1 = analogRead(IN1); // Reads voltage from pin 1.
  
  float d = 2.1;  // 2 - 2.5 is required to make a 90˚ turn on the robot. (2.2 seems to be working the best so far).
  
  
  calF(2.76); // This function call, as well as the if statement, is only ment to respresent the boarders of the property (house).
  if (sensorValue1 < 0 || sensorValue1 > 1023){  // If voltage is grater than 1 return an error message, else calls stop function, success message, and start function followed by next command.
    errorMessRange();
  }
  else {  // This part of the code moves the robot in a square.
    succMess();
    calStopStart(); 
    calL(d);
    calStopStart();
    calF(1.2);
    calStopStart();
    calL(d);
    calStopStart();
    calF(2.6);
    calStopStart();
    calL(d);
    calStopStart();
    calF(0.44);
    calStopStart();
    calR(d);
    calStopStart();
    calF(0.12);
    calStopStart();
    calL(d);
    calStopStart();
    calF(0.24);
    calStopStart();
    calR(d);
    calStopStart();
    calF(0.04);
    calStopStart();
    calL(d);
    calStopStart();
    calF(0.52);
    calStopStart();
    calL(d);
    }

    // The following code is meant to draw the ditches that will be dug up on the inside of the property (house).
  if (sensorValue1 < 0 || sensorValue1 > 1023){  
    errorMessRange();
  }
  else {  
    succMess();
    calStopStart();
    calF(0.16);
    calStopStart();
    calL(d);
    calStopStart();
    calF(1.2);
    calStopStart();
    calR(d);
    calStopStart();
    calF(0.4333336);
    calStopStart();
    calR(d);
    calStopStart();
    calF(1.2);
    calStopStart();
    calL(d); 
    }


  digitalWrite(STBY,LOW); //This code allows you to stop the code. Writes standby as low permanently.
    while(Serial.available()==0){
    }

}

/*

void calF(float d){
  digitalWrite(IN1,HIGH);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,HIGH);
  float t = d/3.583333 * 1000;  // Time dealy based on distance that needs to be traveled.
  delay(t);
}

void calB(float d){
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,LOW);
  float t = d/3.583333 * 1000;  // Time dealy based on distance that needs to be traveled.
  delay(t);
}

void calR(float d){
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  delay(d*80); // About 45˚ per 80 milliseconds
}

void calL(float d){
  digitalWrite(IN1,HIGH);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
  delay(d*80); // About 45˚ per 80 milliseconds
}

void errorMessRange(){
  Serial.println("Error: Sensor value out of range.");
}

void errorMessVol(){
  Serial.println("Error: Motors still have voltage.");
}

void succMess(){
  Serial.println("Acceptable sensor value.");
}

void calStopStart(){ // Delays stop for 2 seconds then starts again.
  digitalWrite(STBY, LOW);
  delay(2000);
  digitalWrite(STBY, HIGH);
}

*/